/* Melody: Plays a melody created 21 Jan 2010
 *  modified 30 Aug 2011 by Tom Igoe
 *  This example code is in the public domain. http://www.arduino.cc/en/Tutorial/Tone
 *  
 *  modified J. Gálvez 04.07.21: *1
 *  - 8 ohm speaker on digital pin 12
 *  - added Pitches library for music notes
 *  - changed melody and number of music notes
*/

#include "pitches.h"

// notes in the melody:
int melody_test[] = {                                     //*1 number of music notes in this sketch: 16
  NOTE_E4, NOTE_F4, NOTE_G4, NOTE_E4, NOTE_E4, NOTE_F4, NOTE_G4, NOTE_E4, 0, NOTE_G4, NOTE_A4, NOTE_B4, NOTE_G4, NOTE_A4, NOTE_B4, 0,
};

// note durations: 4 = quarter note, 8 = eighth note, etc.:
int noteDurations_test[] = {                          //*1 duration for 16 music notes
  4, 4, 4, 4, 4, 4, 4, 4, 8, 4, 4, 2, 4, 4, 2, 8
};

void setup() {
  // iterate over the notes of the melody:
  for (int thisNote = 0; thisNote < 16; thisNote++) {     //*1 16 is the number of music notes

    // to calculate the note duration, take one second divided by the note type.
    //e.g. quarter note = 1000 / 4, eighth note = 1000/8, etc.
    int noteDuration = 1000 / noteDurations_test[thisNote];
    tone(12, melody_test[thisNote], noteDuration);

    // to distinguish the notes, set a minimum time between them.
    // the note's duration + 30% seems to work well:
    int pauseBetweenNotes = noteDuration * 1.23;
    delay(pauseBetweenNotes);
    // stop the tone playing:
    noTone(12);
  }
}

void loop() {
  // no need to repeat the melody.
}
