/*
 * Arduino Kexboard by https://www.hackster.io/Noshirt/arduino-keyboard-faea5d
 * 
 * modified J. Gálvez 04.07.21: *1
 *  - 8 ohm speaker on digital pin 12
 *  - include library pitches.h https://www.arduino.cc/en/Tutorial/BuiltInExamples/toneMelody 
 *  - add an oled display to read the notes 
 *  - include adapted code HelloWorldWire.ino https://github.com/greiman/SSD1306Ascii
*/

#include "pitches.h"
const int Pin_LED = 13;           //*1 added const int for the LED and speaker
const int Pin_Speaker = 12;

const int C4 = 4;
const int D4 = 5;
const int E4 = 6;
const int F4 = 7;
const int G4 = 8;
const int A_4 = 9;
const int B4 = 10;
const int C5 = 11;

int duration(200);                 //*1 10 Miliseconds, the sound stops as soon as you stop pressing the button
                                    //*1 no int definitions for the music notes are necessary
#include <Wire.h>
#include "SSD1306Ascii.h"
#include "SSD1306AsciiWire.h"
#define I2C_ADDRESS 0x3C
// Define proper RST_PIN if required.
#define RST_PIN -1
SSD1306AsciiWire oled;

void setup() {
  Wire.begin();
  Wire.setClock(400000L);
  oled.begin(&Adafruit128x64, I2C_ADDRESS);
  oled.setFont(System5x7);
  
  pinMode(Pin_LED, OUTPUT);
  pinMode(C4, INPUT);           //*1 no pullup, the state of the pin is low and then goes high when the button is pressed
  pinMode(D4, INPUT);
  pinMode(E4, INPUT);
  pinMode(F4, INPUT);
  pinMode(G4, INPUT);
  pinMode(A_4, INPUT);
  pinMode(B4, INPUT);
  pinMode(C5, INPUT);
  oled.set2X();                 //*1 set up font size x2
}

void loop() {
  if (digitalRead(C4) == HIGH) {          //Reads button state when pressed
    tone(Pin_Speaker, NOTE_C4, duration); //*1 changed pin number with const int defined
    oled.clear();                         //*1 clears the displayed text for a new one
    oled.println("NOTE C4");              //*1 display the music note played
    delay(100);
  }
  if (digitalRead(D4) == HIGH) {
      tone(Pin_Speaker, NOTE_D4, duration); 
      oled.clear();
      oled.println("NOTE D4");
      delay(100);
  }
  if (digitalRead(E4) == HIGH) {
      tone(Pin_Speaker, NOTE_E4, duration); 
      oled.clear();
      oled.println("NOTE E4");
      delay(100);
  }
  if (digitalRead(F4) == HIGH) {
      tone(Pin_Speaker, NOTE_F4, duration);
      oled.clear();
      oled.println("NOTE F4");
      delay(100);
  }
  if (digitalRead(G4) == HIGH) {
      tone(Pin_Speaker, NOTE_G4, duration);
      oled.clear();
      oled.println("NOTE G4");
      delay(100); 
  }
  if (digitalRead(A_4) == HIGH) {
      tone(Pin_Speaker, NOTE_A4, duration);
      oled.clear();
      oled.println("NOTE A4");
      delay(100); 
  }
  if (digitalRead(B4) == HIGH) {
      tone(Pin_Speaker, NOTE_B4, duration);
      oled.clear();
      oled.println("NOTE B4");
      delay(100); 
  }
  if (digitalRead(C5) == HIGH) {
      tone(Pin_Speaker, NOTE_C5, duration);
      oled.clear();
      oled.println("NOTE C5");
      delay(100); 
  }
  
}
